Const HKEY_CURRENT_USER = &H80000001

Const ForWriting        = 2
Const TemporaryFolder   = 2

Const REG_SZ            = 1
Const REG_EXPAND_SZ     = 2
Const REG_BINARY        = 3
Const REG_DWORD         = 4
Const REG_MULTI_SZ      = 7

Dim objFSO, objShell, objWMI
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objShell = CreateObject("WScript.Shell")
Set ObjWMI = GetObject("winmgmts:\\.\root\CIMV2")

TempFolder = objFSO.GetSpecialFolder(TemporaryFolder)
LogFile = TempFolder & "\" & "zarafa_recover_settings-" & Year(Now) & Month(Now) & Day(Now) & "-" & Hour(Now) & Minute(Now) & Second(Now) & ".log"

Set objLog = objFSO.CreateTextFile(LogFile, For_Writing, True)

strComputer = "."
Set objRegistry = GetObject("winmgmts:\\" & strComputer & "\root\default:StdRegProv") 

Function KeyExists(Key, KeyPath)
    If objRegistry.EnumKey(Key, KeyPath, arrSubKeys) = 0 Then
        KeyExists = True
    Else
        KeyExists = False
   End If
End Function

Function hex2str(arrBytes)
	strBytes = ""
	For Each uByte in arrBytes
		If CInt(uByte) <= 15 Then
			strBytes = strBytes & "0" & Hex(uByte)
		Else
			strBytes = strBytes & Hex(uByte)
		End If
	Next
	hex2str = strBytes
End Function

Function CopyValues(FromKey, ToKey)
	objLog.WriteLine "Copying all values" & vbCrlf & "   From: " & FromKey & vbCrlf & "   To:   " & ToKey
	objRegistry.EnumValues HKEY_CURRENT_USER, FromKey, arrValueNames, arrTypes
	For i = LBound(arrValueNames) To UBound(arrValueNames)
		strValueName = arrValueNames(i)
		Select Case arrTypes(i)
		Case REG_SZ          
			objRegistry.GetStringValue HKEY_CURRENT_USER, FromKey, strValueName, strValue
			objLog.WriteLine "  " & strValueName & " (REG_SZ)         = " & strValue
			objRegistry.SetStringValue HKEY_CURRENT_USER, ToKey, strValueName, strValue

		Case REG_EXPAND_SZ
			objRegistry.GetExpandedStringValue HKEY_CURRENT_USER, FromKey, strValueName, strValue
			wobjLog.WriteLine "  " & strValueName & " (REG_EXPAND_SZ) = " & strValue
			objRegistry.SetExpandedStringValue HKEY_CURRENT_USER, ToKey, strValueName, strValue

		Case REG_BINARY
			objRegistry.GetBinaryValue HKEY_CURRENT_USER, FromKey, strValueName, arrBytes
			strBytes = ""
			For Each uByte in arrBytes
			  strBytes = strBytes & Hex(uByte) & " "
			Next
			objLog.WriteLine "  " & strValueName & " (REG_BINARY)     = " & strBytes
			objRegistry.SetBinaryValue HKEY_CURRENT_USER, ToKey, strValueName, arrBytes

		Case REG_DWORD
			objRegistry.GetDWORDValue HKEY_CURRENT_USER, FromKey, strValueName, uValue
			objLog.WriteLine "  " & strValueName & " (REG_DWORD)      = " & CStr(uValue)
			objRegistry.SetDWORDValue HKEY_CURRENT_USER, ToKey, strValueName, uValue

		Case REG_MULTI_SZ
			objRegistry.GetMultiStringValue HKEY_CURRENT_USER, FromKey, strValueName, arrValues				  				
			objLog.WriteLine "  " & strValueName & " (REG_MULTI_SZ)   ="
			For Each strValue in arrValues
			  objLog.WriteLine "    " & strValue 
			Next
			objRegistry.SetMultiStringValue HKEY_CURRENT_USER, ToKey, strValueName, arrValues

    End Select
  Next
End Function

Function FindSettings(strBaseKeyPath)
	bReboot = False
	objLog.Write "Checking logged on user..."
	' if the Outlook Profile key is not existing continue
	If KeyExists(HKEY_CURRENT_USER, strBaseKeyPath) Then
		objLog.WriteLine "found an outlook profile registry key."
		' Now iterate through the profiles
		objRegistry.EnumKey HKEY_CURRENT_USER, strBaseKeyPath, arrSubkeysProfiles
		If Not IsNull(arrSubkeysProfiles) then
			For Each strSubKeyProfiles in arrSubKeysProfiles
				objLog.Write "Found outlook profile " & strSubKeyProfiles & "..."
				strKeyCurrentProfile = strBaseKeyPath & strSubKeyProfiles
				strKeyZSettingsPath = strKeyCurrentProfile & strZarafaSettings
				' Check if the current Profile has a 13dbb0c8aa05101a9bb000aa002fc45a key
				If KeyExists(HKEY_CURRENT_USER, strKeyZSettingsPath) Then
					objLog.WriteLine vbCrlf & "...with zarafa profile settings key:" & vbCrlf & "   " & strKeyZSettingsPath
					' And now check if there's a Zarafa Server String aka 001e6700
					objRegistry.GetStringValue HKEY_CURRENT_USER,strKeyZSettingsPath,"001e6700",strZServer
					strOutlookSettingsKey = strKeyCurrentProfile & strOutlookSettings
					' Check if the <profile name>\0a0d020000000000c000000000000046\01023d15 value exists
					If objRegistry.GetBinaryValue(HKEY_CURRENT_USER, strOutlookSettingsKey, "01023d15", arrFromKey) = 0 Then
						hasKey = true
					Else
						hasKey = false
					End If
					If Not IsNull (strZServer) Then 
						' If the correct value is existing go to the next profile
						objLog.WriteLine "Zarafa client registry settings on profile " & strSubKeyProfiles & " are ok."
					ElseIf hasKey Then 
						objLog.WriteLine "Outlook Profile Value found:" & vbCrLf _
							& "   " & strOutlookSettingsKey & "01023d15 ..."
						' If we found it convert the hex array to the key name
						strFromKey = hex2str(arrFromKey)
						' Copy everything from there
						CopyValues strKeyCurrentProfile & "\" & strFromKey & "\", strKeyZSettingsPath
						' Then delete the 01023d15 Value
						objLog.Write "Deleting ./" & strSubKeyProfiles & "/01023d15 ..."
						rc = objRegistry.DeleteValue(HKEY_CURRENT_USER, strOutlookSettingsKey, "01023d15")
						If rc <> 0 Then objLog.WriteLine "FAILED." Else objLog.WriteLine "done."
						bReboot = True
					Else ' If the 01023d15 was not found try finding zarafa settings by 001e6700 and 001f6701 values
						' Iterate trough all the subkeys of \Software\Microsoft\Office\15.0\Outlook\Profiles\<profilename>
						' and search for the one with the Settings
						objRegistry.EnumKey HKEY_CURRENT_USER, strKeyCurrentProfile, arrSubkeysFromCurrentProfile
						For Each strSubkeysFromCurrentProfile in arrSubkeysFromCurrentProfile
							If Not "\" & strSubkeysFromCurrentProfile & "\" = strZarafaSettings Then
								strProfileSubKey = strKeyCurrentProfile & "\" & strSubkeysFromCurrentProfile & "\"
								objRegistry.GetStringValue HKEY_CURRENT_USER, strProfileSubKey, "001e6700",strZServerWrongPlace
								objRegistry.GetBinaryValue HKEY_CURRENT_USER, strProfileSubKey, "001f6701",strBinValWrongPlace
								If Not IsNull (strZServerWrongPlace) And Not IsNull(strBinValWrongPlace) And strZServerWrongPlace <> "Server" Then 
									objLog.WriteLine "Found zarafa client registry settings in wrong place: " & vbCrlf & "   " & strProfileSubKey
									'Now copy all the entries from strProfileSubKey to strKeyZSettingsPath
									CopyValues strProfileSubKey, strKeyZSettingsPath
									bReboot = True
									objLog.Write vbCrlf
								End If
							End If
						Next
					End If
				Else
					objLog.WriteLine "without zarafa profile settings key."
				End If
			Next
		End If
	Else
		objLog.WriteLine "no outlook profile registry found."
	End If
objLog.Write vbCrlf
FindSettings = bReboot
End Function

' Zarafa Settings Key
strZarafaSettings = "\13dbb0c8aa05101a9bb000aa002fc45a\"

' Outlook Settings Key
strOutlookSettings = "\0a0d020000000000c000000000000046\"

' Sub SID path to Query and Operate On For Outlook 2013
strBaseKeyPath = "Software\Microsoft\Office\15.0\Outlook\Profiles\"

' User Messages
Set colItems = ObjWMI.ExecQuery("SELECT * FROM Win32_OperatingSystem")

For Each objItem in colitems
	langid = objItem.Locale 
Next

Select Case langid
	Case "0407","0807","0c07","1007","1407"
		strReboot = "Ihre Zarafa Outlook Profileinstellungen wurden repariert." & vbCrLf &_
			"Sollten Sie Outlook starten ohne davor den Computer neuzustarten, " & vbCrLf &_
			"muss dieses Skript nochmals ausgefhrt werden!" & vbCrLf &_
			"Computer jetzt neustarten?"
		strTitle = "Profil reparieren"
		strNothingToDo = "Es wurden keine Outlook Profile repariert."
	Case Else
		strReboot = "Your Zarafa Outlook profile settings have been repaired." & vbCrLf &_
			"If you start Outlook before rebooting this computer, " & vbCrLf &_
			"you will have to run this script again!" & vbCrLf &_
			"Reboot Computer now?"
		strTitle = "Repair profile"
		strNothingToDo = "No Outlook profile repaired."
End Select

' Find the wrong settings an copy them if so for OL2013
objLog.WriteLine "####################################"
objLog.WriteLine "Searching for Outlook 2013 profiles."  & vbCrlf
bReboot13 = FindSettings(strBaseKeyPath)
objLog.WriteLine "####################################" & vbCrlf

' Sub SID path to Query and Operate On For Outlook 2010
strBaseKeyPath = "Software\Microsoft\Windows NT\CurrentVersion\Windows Messaging Subsystem\Profiles\"

' Find the wrong settings an copy them if so for OL2010
objLog.WriteLine "####################################"
objLog.WriteLine "Searching for Outlook 2010 profiles." & vbCrlf
bReboot10 = FindSettings(strBaseKeyPath)
objLog.WriteLine "####################################"
objLog.Close

If bReboot13 Or bReboot10 Then
	iButton = objShell.Popup(strReboot,,strTitle,65)
	If iButton = 1 Then 
		objShell.Run "%comspec% /c shutdown /r /t 5 /f", , TRUE
	End If
Else
	wscript.echo strNothingToDo
End If
wscript.Quit(0)

'' SIG '' Begin signature block
'' SIG '' MIIMMgYJKoZIhvcNAQcCoIIMIzCCDB8CAQExDjAMBggq
'' SIG '' hkiG9w0CBQUAMGYGCisGAQQBgjcCAQSgWDBWMDIGCisG
'' SIG '' AQQBgjcCAR4wJAIBAQQQTvApFpkntU2P5azhDxfrqwIB
'' SIG '' AAIBAAIBAAIBAAIBADAgMAwGCCqGSIb3DQIFBQAEENcZ
'' SIG '' wYKXoh3IiW2ru10iOWWgggmkMIIEmTCCA4GgAwIBAgIQ
'' SIG '' caC3NpXdsa/COyuaGO5UyzANBgkqhkiG9w0BAQsFADCB
'' SIG '' qTELMAkGA1UEBhMCVVMxFTATBgNVBAoTDHRoYXd0ZSwg
'' SIG '' SW5jLjEoMCYGA1UECxMfQ2VydGlmaWNhdGlvbiBTZXJ2
'' SIG '' aWNlcyBEaXZpc2lvbjE4MDYGA1UECxMvKGMpIDIwMDYg
'' SIG '' dGhhd3RlLCBJbmMuIC0gRm9yIGF1dGhvcml6ZWQgdXNl
'' SIG '' IG9ubHkxHzAdBgNVBAMTFnRoYXd0ZSBQcmltYXJ5IFJv
'' SIG '' b3QgQ0EwHhcNMTMxMjEwMDAwMDAwWhcNMjMxMjA5MjM1
'' SIG '' OTU5WjBMMQswCQYDVQQGEwJVUzEVMBMGA1UEChMMdGhh
'' SIG '' d3RlLCBJbmMuMSYwJAYDVQQDEx10aGF3dGUgU0hBMjU2
'' SIG '' IENvZGUgU2lnbmluZyBDQTCCASIwDQYJKoZIhvcNAQEB
'' SIG '' BQADggEPADCCAQoCggEBAJtVAkwXBenQZsP8KK3TwP7v
'' SIG '' 4Ol+1B72qhuRRv31Fu2YB1P6uocbfZ4fASerudJnyrcQ
'' SIG '' JVP0476bkLjtI1xC72QlWOWIIhq+9ceu9b6KsRERkxoi
'' SIG '' qXRpwXS2aIengzD5ZPGx4zg+9NbB/BL+c1cXNVeK3VCN
'' SIG '' A/hmzcp2gxPI1w5xHeRjyboX+NG55IjSLCjIISANQbcL
'' SIG '' 4i/CgOaIe1Nsw0RjgX9oR4wrKs9b9IxJYbpphf1rAHgF
'' SIG '' JmkTMIA4TvFaVcnFUNaqOIlHQ1z+TXOlScWTaf53lpqv
'' SIG '' 84wOV7oz2Q7GQtMDd8S7Oa2R+fP3llw6ZKbtJ1fB6EDz
'' SIG '' U/K+KTT+X/kCAwEAAaOCARcwggETMC8GCCsGAQUFBwEB
'' SIG '' BCMwITAfBggrBgEFBQcwAYYTaHR0cDovL3QyLnN5bWNi
'' SIG '' LmNvbTASBgNVHRMBAf8ECDAGAQH/AgEAMDIGA1UdHwQr
'' SIG '' MCkwJ6AloCOGIWh0dHA6Ly90MS5zeW1jYi5jb20vVGhh
'' SIG '' d3RlUENBLmNybDAdBgNVHSUEFjAUBggrBgEFBQcDAgYI
'' SIG '' KwYBBQUHAwMwDgYDVR0PAQH/BAQDAgEGMCkGA1UdEQQi
'' SIG '' MCCkHjAcMRowGAYDVQQDExFTeW1hbnRlY1BLSS0xLTU2
'' SIG '' ODAdBgNVHQ4EFgQUV4abVLi+pimK5PbC4hMYiYXN3Lcw
'' SIG '' HwYDVR0jBBgwFoAUe1tFz6/Oy3r9MZIaarbzRutXSFAw
'' SIG '' DQYJKoZIhvcNAQELBQADggEBACQ79degNhPHQ/7wCYdo
'' SIG '' 0ZgxbhLkPx4flntrTB6HnovFbKOxDHtQktWBnLGPLCm3
'' SIG '' 7vmRBbmOQfEs9tBZLZjgueqAAUdAlbg9nQO9ebs1tq2c
'' SIG '' TCf2Z0UQycW8h05Ve9KHu93cMO/G1GzMmTVtHOBg081o
'' SIG '' jylZS4mWCEbJjvx1T8XcCcxOJ4tEzQe8rATgtTOlh5/0
'' SIG '' 3XMMkeoSgW/jdfAetZNsRBfVPpfJvQcsVncfhd1G6L/e
'' SIG '' LIGUo/flt6fBN591ylV3TV42KcqF2EVBcld1wHlb+jQQ
'' SIG '' Bm1kIEK3OsgfHUZkAl/GR77wxDooVNr2Hk+aohlDpG9J
'' SIG '' +PxeQiAohItHIG4wggUDMIID66ADAgECAhASoP/s6Je2
'' SIG '' vMVnBMlLFZxvMA0GCSqGSIb3DQEBCwUAMEwxCzAJBgNV
'' SIG '' BAYTAlVTMRUwEwYDVQQKEwx0aGF3dGUsIEluYy4xJjAk
'' SIG '' BgNVBAMTHXRoYXd0ZSBTSEEyNTYgQ29kZSBTaWduaW5n
'' SIG '' IENBMB4XDTE1MDYxMTAwMDAwMFoXDTE3MDYxMDIzNTk1
'' SIG '' OVowfjELMAkGA1UEBhMCTkwxFTATBgNVBAgMDFp1aWQt
'' SIG '' SG9sbGFuZDEOMAwGA1UEBwwFRGVsZnQxEjAQBgNVBAoM
'' SIG '' CVphcmFmYSBCVjEgMB4GA1UECwwXQXBwbGljYXRpb24g
'' SIG '' RGV2ZWxvcG1lbnQxEjAQBgNVBAMMCVphcmFmYSBCVjCC
'' SIG '' ASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAKgK
'' SIG '' HeUgWwxdPO0RLobYsadkkqvrOI9Az50QSezD3kGwc2AV
'' SIG '' 8wD7hmniQKvkbd2j6GB59P5GoNI5bU42bJmkrkcyO994
'' SIG '' sXrxt5nsnROlBHr+uvIwQfxZjjJLSeH61cFsIwVF5MMY
'' SIG '' T0lDc8gxj+MsQMI+uXK2DNYisgte36naFIXNvbQdNp9y
'' SIG '' hjgIOPuo2QnKDMKMhVIyBh1luojQSB/bxpZNuvQpWnb/
'' SIG '' f3FkGjXvUtHaoi1WWssIPL7jx4fKe7lrgklM1ayY3z8x
'' SIG '' hFiHKZ3VSEact/TlAS5NXCtsWfU7vl2ELvJZ+XuH5RyR
'' SIG '' oxRVzR0oF67FpSd7VLE5A/b8X41UOj0CAwEAAaOCAa0w
'' SIG '' ggGpMAkGA1UdEwQCMAAwHwYDVR0jBBgwFoAUV4abVLi+
'' SIG '' pimK5PbC4hMYiYXN3LcwHQYDVR0OBBYEFHuk9vUP8W3b
'' SIG '' wtgx8/EzWPSJ80RgMCsGA1UdHwQkMCIwIKAeoByGGmh0
'' SIG '' dHA6Ly90bC5zeW1jYi5jb20vdGwuY3JsMA4GA1UdDwEB
'' SIG '' /wQEAwIHgDAfBgNVHSUEGDAWBggrBgEFBQcDAwYKKwYB
'' SIG '' BAGCNwIBFjBzBgNVHSAEbDBqMGgGC2CGSAGG+EUBBzAC
'' SIG '' MFkwJgYIKwYBBQUHAgEWGmh0dHBzOi8vd3d3LnRoYXd0
'' SIG '' ZS5jb20vY3BzMC8GCCsGAQUFBwICMCMMIWh0dHBzOi8v
'' SIG '' d3d3LnRoYXd0ZS5jb20vcmVwb3NpdG9yeTAdBgNVHQQE
'' SIG '' FjAUMA4wDAYKKwYBBAGCNwIBFgMCB4AwVwYIKwYBBQUH
'' SIG '' AQEESzBJMB8GCCsGAQUFBzABhhNodHRwOi8vdGwuc3lt
'' SIG '' Y2QuY29tMCYGCCsGAQUFBzAChhpodHRwOi8vdGwuc3lt
'' SIG '' Y2IuY29tL3RsLmNydDARBglghkgBhvhCAQEEBAMCBBAw
'' SIG '' DQYJKoZIhvcNAQELBQADggEBAEGQ+1LnL7R+2a9/3xXO
'' SIG '' ke/gC9UdA43hYKgQP/5UFvN87DXIIanLS8+DD9UvQrhg
'' SIG '' TmXVe0YYUlEIP6AE6zjEG42Lze9bqmHPch4sTlT9Ib7K
'' SIG '' XyWNhgz6qlbFBIm3V/pHAPMk6FWnf1GXu/gsbfB2zOuR
'' SIG '' lYmann3BN6AAjehnr14Rkp+57azucA5pF/FqbDouVqhA
'' SIG '' 1/w00LqMT92w+sXvmfKo3NtFuzxRhS8GuETQqsX4UL7U
'' SIG '' XixXmHHO3hh7qPiOoIMripAg2fzSRARP03LI4v5t2cO0
'' SIG '' TJ9bxiPNkuXS8CQgb2RMFNtFN2ESCZ5UK4Is2piZ0nMe
'' SIG '' AulEVlTQXIoGQE4xggH4MIIB9AIBATBgMEwxCzAJBgNV
'' SIG '' BAYTAlVTMRUwEwYDVQQKEwx0aGF3dGUsIEluYy4xJjAk
'' SIG '' BgNVBAMTHXRoYXd0ZSBTSEEyNTYgQ29kZSBTaWduaW5n
'' SIG '' IENBAhASoP/s6Je2vMVnBMlLFZxvMAwGCCqGSIb3DQIF
'' SIG '' BQCgbDAQBgorBgEEAYI3AgEMMQIwADAZBgkqhkiG9w0B
'' SIG '' CQMxDAYKKwYBBAGCNwIBBDAcBgorBgEEAYI3AgELMQ4w
'' SIG '' DAYKKwYBBAGCNwIBFjAfBgkqhkiG9w0BCQQxEgQQdPv6
'' SIG '' 6GaRg5ZTj0cPADhotjANBgkqhkiG9w0BAQEFAASCAQCi
'' SIG '' 8Y3FXfKpJzZw0D6i/J0QGZgiWXoScID9fP6rTrDwf4Y4
'' SIG '' 8Syx7QzDj5TlmgDsqO4E9EJE87pLnUV0ckKK2eYa1EtW
'' SIG '' 1gYi6EUNPQkP7A//EQmhC2k0XhyNTz3fblYYhVZCdUcJ
'' SIG '' Ak5q+2OB26insU0FGxVjbh42bYiraAvrxTo3wvHry1np
'' SIG '' jBuwYlINo0W/KHT4p+HltimYbkVzEZJYsIeRnI1RpWox
'' SIG '' YWjbsXwo92WORGlMdGyUmJvlNWRAQwB8X6LVCdVp4Z0W
'' SIG '' kukyLaZdWbLgxEYLoW4B5NuMVZU+pwihTOFS+yNPSad1
'' SIG '' Y9Vo8gWeWuNOYUTTC/dtB0eAj0HTctgx
'' SIG '' End signature block
